package uk.ac.shef;

import com.zerog.awt.ZGStandardDialog;

import java.io.*;
import java.util.*;

public class Utils {
  static final int SKIP_LINES_IN_GATE_BAT = 35;
  static final int SKIP_LINES_IN_GATE_SH = 3;
  static final String MIN_JDK_VER = "1.4";

  static void showErr(String message){
    //Setuptheerrordialog
    ZGStandardDialog zgDialog = new ZGStandardDialog("Install error:", message);
    zgDialog.setModal(true);
    zgDialog.show();
  }

  /**
   *
   * @param vmPath
   * @return "1.3" "1.4" or "" if the selected VM is 1.3 1.4 or non compatible
   */
  static String getVMVersion(String vmPath){

    //find version
    try{
      String command = vmPath + " -version";
      Process proc = Runtime.getRuntime().exec(command);
      BufferedReader reader = new BufferedReader(
                                  new InputStreamReader(proc.getErrorStream()));
      String output = "";
      String line = reader.readLine();
      String firstLine = line;
      while(line != null){
        output += line;
        line = reader.readLine();
      }

      int res = proc.waitFor();
      reader.close();
      if(res == 0){
        int start = firstLine.indexOf('"');
        int end = firstLine.indexOf('"', start +1);
        String version = firstLine.substring(start + 1, end);

        return version;

      }else{
        showErr("Could not determine version for JVM at\n" +
                             vmPath);
        return "";
      }
    }catch(Exception e){
      showErr("Could not determine version for JVM at\n" +
                            vmPath + "\nProblem was:\n" + e.toString());
      return "";
    }
  }//protected String checkVM(String vmPath)

  /**
   * Tests whether a Java VM is JDK or JRE by looking for tools.jar
   *
   * @param vmPath
   * @return true if the VM is a JDK
   */
  static boolean isJDK(String vmPath){
    File javaExFile = new File(vmPath);
    File binFile = javaExFile.getParentFile();
    if(binFile.exists()){
      File rootFile = binFile.getParentFile();
      if (rootFile.exists()) {
        File libFile = new File(rootFile, "lib");
        if (libFile.exists()) {
          File toolsJarFile = new File(libFile, "tools.jar");
          return toolsJarFile.exists();
        }
      }
    }
    return false;
  }

}